﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Class_Globals
	Private imgToTurn As ImageView
	Private timer As Timer
	Private stpH As Float
	Private imgWdt, imgHgt, imgLft, imgWMid As Int 
	Private Rot As Float
	Private Ulx, Uly, Urx, Ury, Lrx, Lry, Llx, Lly As Float 
	Private tBack As Boolean
	Private Bmp As Bitmap
	Private BmpFront As Bitmap
	Private BmpBack As Bitmap
	Private joTurn As JavaObject
	Private cBack As String
	Private Parent As Object
End Sub

'Dim Turn as cTurn
'Turn initialize(Me)
Public Sub Initialize(prt As Object)
	Parent = prt
	joTurn.InitializeContext
	Bmp.Initialize(File.DirAssets, "Cards01.png")
	timer.Initialize("timer",8)
	timer.Enabled = False
End Sub

Public Sub Img_to_Turn(imgV As ImageView, idx As Short, toBack As Boolean, mSub As String)
	imgToTurn = imgV
	tBack = toBack
	cBack = mSub
	imgHgt = imgToTurn.Height
	imgWdt = imgToTurn.Width
	imgLft = imgToTurn.Left	
	Dim BmpFront As Bitmap
	Dim BmpBack As Bitmap
	If tBack Then
		BmpFront = DrawImage(idx)
		BmpBack = DrawImage(55)
		stpH = 0.15
	Else
		BmpBack = DrawImage(idx)
		BmpFront = DrawImage(55)
		stpH = -0.15
	End If
	Rot = imgWdt / 10
	imgWMid = imgWdt / 2
	Ulx = 0: Uly = 0
	Urx = imgWdt: Ury = 0
	Llx = 0: Lly = imgHgt
	Lrx = imgWdt: Lry =  imgHgt
	Dim source() As Float = Array As Float(Llx, Ury, Lrx, Uly, Urx, Lly, Ulx, Lry)
	imgToTurn.Bitmap = joTurn.RunMethod("perspectiveTransformation", Array(BmpFront, source))
	timer.Enabled = True
End Sub

private Sub Turn_Card
	If Ulx > imgWMid Then
		Dim EfTmp As Float
		BmpFront = BmpBack
		EfTmp = Ury
		Ury = Uly
		Uly = EfTmp
		EfTmp = Lry
		Lry = Lly
		Lly = EfTmp
		imgWMid = 99999
		Rot = Rot * -1
	End If
	Ulx = Ulx + Rot: Uly = Uly - stpH 
	Urx = Urx - Rot: Ury = Ury + stpH
	Llx = Llx + Rot: Lly = Lly + stpH 
	Lrx = Lrx - Rot: Lry = Lry - stpH
	imgToTurn.Width = Max(0, Urx - Ulx)
	imgToTurn.Height = Max(Lly - Uly, Lry-Ury) 
	imgToTurn.Left = imgToTurn.Left + Rot
	Dim source() As Float = Array As Float(Llx, Ury, Lrx, Uly, Urx, Lly, Ulx, Lry)
	imgToTurn.Bitmap = joTurn.RunMethod("perspectiveTransformation", Array(BmpFront, source))
	If Ulx < = 0  Then
		timer.Enabled = False
		imgToTurn.Width = imgWdt
		imgToTurn.Height = imgHgt
		imgToTurn.Left = imgLft
		imgToTurn.Bitmap = BmpFront 
		If cBack <> "*" Then CallSubDelayed(Parent, cBack)
	End If		
End Sub

Private Sub DrawImage(cValue As Short) As Bitmap
	Dim cv As Canvas
	Dim BM As Bitmap
	Dim sTmp As Short
	Dim rtSrc As Rect
	Dim rtDst As Rect
	BM.InitializeMutable(imgWdt,imgHgt)
	cv.Initialize2(BM)
	
	#If WithAntiAliasing
		Utils.SetAntiAlias(cv, Utils.FILTER_BITMAP_FLAG)
	#End If
	
	sTmp = cValue Mod 13
	If sTmp = 0 Then sTmp = 13
	Dim cl As Short = 71 * (sTmp-1)
	Dim rw As Short  = (cValue-sTmp)/13
	rw = rw * 96
	rtSrc.Initialize(cl, rw, cl + 71, rw + 96)
	rtDst.Initialize(0, 0, imgWdt, imgHgt)
	cv.DrawBitmap(Bmp, rtSrc, rtDst)	
	Return BM
End Sub

Private Sub timer_tick
	Turn_Card
End Sub

